#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifndef HW_TYPES_H
#define HW_TYPES_H
//    #pragma pack(1)

struct hw16_bits {
    unsigned int b9:1 __attribute__ ((packed));
    unsigned int b10:1 __attribute__ ((packed));
    unsigned int b11:1 __attribute__ ((packed));
    unsigned int b12:1 __attribute__ ((packed));
    unsigned int b13:1 __attribute__ ((packed));
    unsigned int b14:1 __attribute__ ((packed));
    unsigned int b15:1 __attribute__ ((packed));
    unsigned int b16:1 __attribute__ ((packed));
    unsigned int b1:1 __attribute__ ((packed));
    unsigned int b2:1 __attribute__ ((packed));
    unsigned int b3:1 __attribute__ ((packed));
    unsigned int b4:1 __attribute__ ((packed));
    unsigned int b5:1 __attribute__ ((packed));
    unsigned int b6:1 __attribute__ ((packed));
    unsigned int b7:1 __attribute__ ((packed));
    unsigned int b8:1 __attribute__ ((packed));
} __attribute__ ((packed));

struct hw16_tape {
    unsigned int low:6 __attribute__ ((packed));
    unsigned int mid:6 __attribute__ ((packed));
    unsigned int high:4 __attribute__ ((packed));
};

struct hw16_bytes {
    unsigned char low __attribute__ ((packed));
    unsigned char high __attribute__ ((packed));
};

struct hw16_otype {
    unsigned int space1:6 __attribute__ ((packed));
    unsigned int t0_subtype:6 __attribute__ ((packed));
    unsigned int type:4 __attribute__ ((packed));
};

typedef struct {
    unsigned int space3:6 __attribute__ ((packed)) __attribute__ ((packed));	//Erster Block
    unsigned int S:6 __attribute__ ((packed));
    unsigned int T:4 __attribute__ ((packed));
    unsigned int space1:8 __attribute__ ((packed));	// Zweiter Block
    unsigned int N:6 __attribute__ ((packed));
    unsigned int space2:2 __attribute__ ((packed));
} head0;
typedef head0 head0_0;

typedef struct {
    unsigned int space3:6 __attribute__ ((packed));	//Erster Block
    unsigned int S:6 __attribute__ ((packed));
    unsigned int T:4 __attribute__ ((packed));
} head0_23;
typedef head0_23 head0_2;
typedef head0_23 head0_3;


typedef struct {
    unsigned int A1:6 __attribute__ ((packed));
    unsigned int N:6 __attribute__ ((packed));
    unsigned int T:4 __attribute__ ((packed));
    unsigned int I:8 __attribute__ ((packed));
    unsigned int A2:8 __attribute__ ((packed));
} head12;
typedef head12 head1;
typedef head12 head2;

typedef struct {
    unsigned int A1:6 __attribute__ ((packed));
    unsigned int space1:6 __attribute__ ((packed));
    unsigned int T:4 __attribute__ ((packed));
    unsigned int space2:8 __attribute__ ((packed));
    unsigned int A2:8 __attribute__ ((packed));
} head34;
typedef head34 head3;
typedef head34 head4;

typedef struct {
    unsigned int A:6 __attribute__ ((packed));
    unsigned int OP:4 __attribute__ ((packed));
    unsigned int T2:1 __attribute__ ((packed));
    unsigned int F:1 __attribute__ ((packed));
    unsigned int T:4 __attribute__ ((packed));
} head57;
typedef head57 head5;
typedef head57 head7;

typedef struct {
    unsigned int A1:6 __attribute__ ((packed));
    unsigned int space1:6 __attribute__ ((packed));
    unsigned int T:4 __attribute__ ((packed));
    unsigned int B:8 __attribute__ ((packed));
    unsigned int A2:8 __attribute__ ((packed));
} head6;


typedef union{
    unsigned int value __attribute__ ((packed));

    struct {
	unsigned int type:3; //Immer 0
	unsigned int space:5;
	unsigned int data:16;
    } generic;

     struct{
     unsigned int one:1;
     unsigned int R:2;
     unsigned int ADDRESS:15;
     unsigned int OP:4;
     unsigned int T:1;
     unsigned int F:1;
     }op_known_address;
    
    struct{
    unsigned int two:3;
    unsigned int SYMBOL_NUMBER:14;
    unsigned int zero:1;
     unsigned int OP:4;
     unsigned int T:1;
     unsigned int F:1;
    }op_symbolic_address;
        
    struct {
    unsigned int four:3;
    unsigned int ADDRESS:16;
    unsigned int R:2;
    unsigned int space:1;
    unsigned int T:1;
    unsigned int F:1;
    } known_address;
    
    struct {
    unsigned int six:3;
    unsigned int SYMBOL_NUMBER:14;
    unsigned int space:5;
    unsigned int T:1;
    unsigned int F:1;
    } symbolic_address;          

}type_0_4_data; 
    
    

typedef union {
    struct hw16_bits bits __attribute__ ((packed));
    struct hw16_bytes bytes __attribute__ ((packed));
    struct hw16_tape tape __attribute__ ((packed));
    struct hw16_otype blocktype __attribute__ ((packed));
    unsigned short value __attribute__ ((packed));
} hw16;

enum {BT_DATA,BT_STOP};

typedef struct {
    int size;
    int type;
    hw16 *data;
    unsigned char * raw_data;
} datablock;


#endif
