/******************************************************************************
 * 
 * LDC2 source code
 *
 * $Date: 2007/03/26 01:00:38 $
 * $Author: hachti $
 *
 * $Log: broken_block.cpp,v $
 * Revision 2.0  2007/03/26 01:00:38  hachti
 * *** empty log message ***
 *
 *
 ******************************************************************************/
 

#include "broken_block.hh"

using namespace std;

/*!
 *\brief Specialisation constructor.
 */
broken_block::broken_block(tape_block& org)
  :tape_block(org)
{
  block_type=TBT_BROKEN;
}

/*!
 *\brief Describe the block.
 *\return A vector of text lines describing this block.
 */
vector<string> broken_block::get_description(){
  vector<string> result;
  string r_string="*********  (B-B)     Broken block";
  result.insert(result.end(),r_string);
  return result;
}

/*!
 *\brief Determine if the block marks the end of an object
 *\retval true The block marks the end of an object.
 *\retval false The block does not mark the end of an object.
 */
bool broken_block::get_obj_end(){
  return false;
}

