/******************************************************************************
 * 
 * LDC2 source code
 *
 * $Date: 2007/05/30 01:33:08 $
 * $Author: hachti $
 *
 * $Log: data_block_3.cpp,v $
 * Revision 2.1  2007/05/30 01:33:08  hachti
 * Corrected handling for FORTRAN data blocks 3 and 4: added endblock capability.
 *
 * Revision 2.0  2007-03-26 01:00:39  hachti
 * *** empty log message ***
 *
 *
 ******************************************************************************/
 
#include "data_block_3.hh"

/*!
 *\brief Specialisation constructor.
 */
data_block_3::data_block_3(data_block & org)
  :data_block(org)
{
  m_has_known_type=false;
}


/*!
 *\brief Describe the block.
 *\return A vector of text lines describing this block.
 */
vector<string> data_block_3::get_description(){
  vector<string> result;
  result.insert(result.end(),"           "+get_typestring()+"End Jump, absolute address");
  return result;
}

/***************************************************************/
/*!
 *\brief Determine if the block marks the end of an object
 *\return true because this block is an end block.
 */
bool data_block_3::is_endblock(){
  return true;
}



